Summary:        OpenStack Image Service (Glance)
Name:           openstack-glance
Version:        25.1.0
Release:        4%{?dist}
License:        ASL 2.0
URL:            https://docs.openstack.org/glance
Source0:        https://tarballs.opendev.org/openstack/glance/glance-%{version}.tar.gz
Source1:        openstack-glance.logrotate
Source2:        openstack-glance-api.service

BuildRequires:  qemu-img systemd python3-os-win python3-paste python3-paste-deploy python3-prettytable
BuildRequires:  python3-routes python3-sqlalchemy python3-WSME python3-webob python3-alembic python3-cryptography
BuildRequires:  python3-castellan python3-cursive python3-debtcollector python3-defusedxml python3-eventlet
BuildRequires:  python3-futurist python3-glance-store python3-httplib2 python3-iso8601 python3-jsonschema
BuildRequires:  python3-keystoneauth1 python3-keystoneclient python3-keystonemiddleware python3-oslo-concurrency
BuildRequires:  python3-oslo-config python3-oslo-context python3-oslo-db python3-oslo-i18n python3-oslo-log
BuildRequires:  python3-oslo-messaging python3-oslo-middleware python3-oslo-policy python3-oslo-reports
BuildRequires:  python3-oslo-upgradecheck python3-oslo-utils python3-osprofiler python3-pbr python3-pyOpenSSL
BuildRequires:  python3-retrying python3-six python3-sqlparse python3-stevedore python3-taskflow python3-hacking
BuildRequires:  python3-babel python3-coverage python3-ddt python3-fixtures python3-requests python3-testrepository
BuildRequires:  python3-testresources python3-testscenarios python3-testtools python3-psutil python3-oslotest
BuildRequires:  python3-stestr python3-doc8 python3-pygments python3-boto3 python3-PyMySQL python3-psycopg2
BuildRequires:  python3-pysendfile python3-xattr python3-swiftclient python3-cinderclient python3-os-brick python3-oslo-privsep
BuildRequires:  python3-oslo-limit
Requires:       openstack-glance-api = %{version}-%{release}
BuildArch:      noarch

%description
The Glance project provides a service where users can upload and discover data assets that are meant
to be used with other services. This currently includes images and metadata definitions.  Glance
image services include discovering, registering, and retrieving virtual machine images. Glance has a
RESTful API that allows querying of VM image metadata as well as retrieval of the actual image.  VM
images made available through Glance can be stored in a variety of locations from simple filesystems
to object-storage systems like the OpenStack Swift project.

%package api
Summary:        OpenStack Image service (Glance) - API
Requires:         python3-glance = %{version}-%{release} logrotate
%{?systemd_requires}
Requires(pre):    shadow-utils

%description api
The Glance project provides a service where users can upload and discover data assets that are meant
to be used with other services. This currently includes images and metadata definitions.  Glance
image services include discovering, registering, and retrieving virtual machine images. Glance has a
RESTful API that allows querying of VM image metadata as well as retrieval of the actual image.  VM
images made available through Glance can be stored in a variety of locations from simple filesystems
to object-storage systems like the OpenStack Swift project.

This package contains the %{name} API server.

%package -n     python3-glance
Summary:        OpenStack Image Service (Glance) - Python module
Requires: python3-paste python3-paste-deploy python3-prettytable python3-routes python3-sqlalchemy
Requires: python3-WSME python3-webob python3-alembic python3-cryptography python3-castellan python3-cursive
Requires: python3-debtcollector python3-defusedxml python3-eventlet python3-futurist python3-glance-store
Requires: python3-httplib2 python3-iso8601 python3-jsonschema python3-keystoneauth1 python3-keystoneclient
Requires: python3-keystonemiddleware python3-oslo-concurrency python3-oslo-config python3-oslo-context
Requires: python3-oslo-db python3-oslo-i18n python3-oslo-log python3-oslo-messaging python3-oslo-middleware
Requires: python3-oslo-policy python3-oslo-reports python3-oslo-upgradecheck python3-oslo-utils
Requires: python3-osprofiler python3-pbr python3-pyOpenSSL python3-retrying python3-six python3-sqlparse
Requires: python3-stevedore python3-taskflow python3-os-win
Requires: python3-oslo-limit

%description -n python3-glance
The Glance project provides a service where users can upload and discover data assets that are meant
to be used with other services. This currently includes images and metadata definitions.  Glance
image services include discovering, registering, and retrieving virtual machine images. Glance has a
RESTful API that allows querying of VM image metadata as well as retrieval of the actual image.  VM
images made available through Glance can be stored in a variety of locations from simple filesystems
to object-storage systems like the OpenStack Swift project.

This package contains the Glance Python library.

%prep
%autosetup -p1 -n glance-%{version} 

%build
%{py3_build}
for service in api scrubber cache manage image-import; do
    PYTHONPATH=. oslo-config-generator --config-file etc/oslo-config-generator/glance-$service.conf
done
PYTHONPATH=. oslopolicy-sample-generator --config-file=etc/glance-policy-generator.conf --output etc/policy.json
rm -f etc/glance-policy-generator.conf

%install
%{py3_install}
install -d -m 755 %{buildroot}%{_sysconfdir}/glance
install -d -m 755 %{buildroot}%{_sysconfdir}/glance/glance.conf.d/
install -d -m 755 %{buildroot}%{_sysconfdir}/glance/glance-api.conf.d/
install -d -m 755 %{buildroot}%{_localstatedir}/lib/glance
install -d -m 755 %{buildroot}%{_localstatedir}/lib/glance/images
install -d -m 750 %{buildroot}%{_localstatedir}/log/glance
install -d -m 750 %{buildroot}%{_localstatedir}/cache/glance
install -d -m 700 %{buildroot}%{_rundir}/glance
cp -pr etc/* %{buildroot}%{_sysconfdir}/glance
for service in api scrubber cache manage swift image-import; do
    mv %{buildroot}%{_sysconfdir}/glance/glance-$service.conf{.sample,}
done
rm -rf %{buildroot}%{_sysconfdir}/glance/oslo-config-generator

install -p -D -m 444 %{SOURCE2} %{buildroot}%{_unitdir}/openstack-glance-api.service
install -p -D -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/logrotate.d/openstack-glance
mv %{buildroot}%{_prefix}%{_sysconfdir}/glance/metadefs/* %{buildroot}%{_sysconfdir}/glance/metadefs
rm -rf %{buildroot}%{_prefix}%{_sysconfdir}/glance

%pre api
getent group glance >/dev/null || {
    oldg=$(getent group openstack-glance |cut -d: -f3) || :
    [ -n "$oldg" ] && oldg="-o -g $oldg"
    [ -n "$oldg" ] && groupdel openstack-glance || :
    [ -z "$oldg" ] && oldg=""
    groupadd -r glance $oldg
} 
getent passwd glance >/dev/null || {
    useradd -r -g glance  -d /var/lib/glance  -s /sbin/nologin -c "OpenStack glance Daemon" glance
}

%check

%post api
%systemd_post %{name}-api.service

%preun api
%systemd_preun %{name}-api.service

%postun api
%systemd_postun_with_restart %{name}-api.service

%files

%files api
%license LICENSE
%dir %attr(0750, root, glance) %{_sysconfdir}/glance
%dir %attr(0750, root, glance) %{_sysconfdir}/glance/glance.conf.d/
%dir %attr(0750, root, glance) %{_sysconfdir}/glance/glance-api.conf.d/
%config(noreplace) %attr(0640, root, glance) %{_sysconfdir}/glance/glance-api.conf
%config(noreplace) %attr(0640, root, glance) %{_sysconfdir}/glance/glance-cache.conf
%config(noreplace) %attr(0640, root, glance) %{_sysconfdir}/glance/glance-image-import.conf
%config(noreplace) %attr(0640, root, glance) %{_sysconfdir}/glance/glance-scrubber.conf
%config(noreplace) %attr(0640, root, glance) %{_sysconfdir}/glance/glance-swift.conf
%config(noreplace) %attr(0640, root, glance) %{_sysconfdir}/glance/glance-manage.conf
%config %{_sysconfdir}/glance/glance-api-paste.ini
%config %{_sysconfdir}/glance/policy.json
%config %{_sysconfdir}/glance/property-protections-policies.conf.sample
%config %{_sysconfdir}/glance/property-protections-roles.conf.sample
%config %{_sysconfdir}/glance/ovf-metadata.json.sample
%config %{_sysconfdir}/glance/schema-image.json
%dir %config %{_sysconfdir}/glance/metadefs
%{_sysconfdir}/glance/metadefs/README
%config %{_sysconfdir}/glance/metadefs/*.json
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%{_unitdir}/openstack-glance-api.service
%dir %attr(0755, glance, glance) %{_localstatedir}/lib/glance
%dir %attr(0755, glance, glance) %{_localstatedir}/lib/glance/images
%dir %attr(0750, glance, glance) %{_localstatedir}/log/glance
%dir %attr(0750, glance, glance) %{_localstatedir}/cache/glance
%{_bindir}/glance*

%files -n python3-glance
%license LICENSE
%{python3_sitelib}/glance*

%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 25.1.0-4
- Rebuilt for loongarch release

* Fri Oct 29 2023 jackeyji <jackeyji@tencent.com> - 25.1.0-3
- Rebuild for qemu CVE fix

* Wed Oct 11 2023 Shuo Wang <abushwang@tencent.com> - 25.1.0-2
- add Requires to python3-oslo-limit

* Sat Oct 07 2023 jackeyji <jackeyji@tencent.com> - 25.1.0-1
- upgrade to 25.1.0

* Mon Sep 18 2023 Miaojun Dong <zoedong@tencent.com> - 22.1.0-5
- Rebuild for pyOpenSSL-23.2.0

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 22.1.0-4
- Rebuilt for OpenCloudOS Stream 23.09

* Mon May 15 2023 Shuo Wang <abushwang@tencent.com> - 22.1.0-3
- add requires python3-os-win

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 22.1.0-2
- Rebuilt for OpenCloudOS Stream 23.05

* Tue Apr 18 2023 Shuo Wang <abushwang@tencent.com> - 22.1.0-1
- initial build
